diff --git a/ChangeLog b/ChangeLog
index 35347e2..e00fd0d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,14 @@
 2015-07-07  H.J. Lu  <hongjiu.lu@intel.com>
 
+	* sysdeps/x86_64/tst-auditmod10b.c (la_symbind32): New.
+	* sysdeps/x86_64/tst-auditmod4b.c (la_symbind32): Likewise.
+	* sysdeps/x86_64/tst-auditmod5b.c (la_symbind32): Likewise.
+	* sysdeps/x86_64/tst-auditmod6b.c (la_symbind32): Likewise.
+	* sysdeps/x86_64/tst-auditmod6c.c (la_symbind32): Likewise.
+	* sysdeps/x86_64/tst-auditmod7b.c (la_symbind32): Likewise.
+
+2015-07-07  H.J. Lu  <hongjiu.lu@intel.com>
+
 	* sysdeps/i386/Makefile (gen-as-const-headers)[elf]: Add
 	link-defines.sym.
 	* sysdeps/i386/dl-trampoline.S: Include <link-defines.h>.
diff --git a/sysdeps/x86_64/tst-auditmod10b.c b/sysdeps/x86_64/tst-auditmod10b.c
index 9bb6127..0eb3674 100644
--- a/sysdeps/x86_64/tst-auditmod10b.c
+++ b/sysdeps/x86_64/tst-auditmod10b.c
@@ -102,6 +102,16 @@ la_objclose  (uintptr_t *cookie)
 }
 
 uintptr_t
+la_symbind32 (Elf32_Sym *sym, unsigned int ndx, uintptr_t *refcook,
+	      uintptr_t *defcook, unsigned int *flags, const char *symname)
+{
+  printf ("symbind32: symname=%s, st_value=%#lx, ndx=%u, flags=%u\n",
+	  symname, (long int) sym->st_value, ndx, *flags);
+
+  return sym->st_value;
+}
+
+uintptr_t
 la_symbind64 (Elf64_Sym *sym, unsigned int ndx, uintptr_t *refcook,
 	      uintptr_t *defcook, unsigned int *flags, const char *symname)
 {
diff --git a/sysdeps/x86_64/tst-auditmod4b.c b/sysdeps/x86_64/tst-auditmod4b.c
index 80aaedc..2b0d827 100644
--- a/sysdeps/x86_64/tst-auditmod4b.c
+++ b/sysdeps/x86_64/tst-auditmod4b.c
@@ -85,6 +85,16 @@ la_objclose  (uintptr_t *cookie)
 }
 
 uintptr_t
+la_symbind32 (Elf32_Sym *sym, unsigned int ndx, uintptr_t *refcook,
+	      uintptr_t *defcook, unsigned int *flags, const char *symname)
+{
+  printf ("symbind32: symname=%s, st_value=%#lx, ndx=%u, flags=%u\n",
+	  symname, (long int) sym->st_value, ndx, *flags);
+
+  return sym->st_value;
+}
+
+uintptr_t
 la_symbind64 (Elf64_Sym *sym, unsigned int ndx, uintptr_t *refcook,
 	      uintptr_t *defcook, unsigned int *flags, const char *symname)
 {
diff --git a/sysdeps/x86_64/tst-auditmod5b.c b/sysdeps/x86_64/tst-auditmod5b.c
index 576183d..a74d261 100644
--- a/sysdeps/x86_64/tst-auditmod5b.c
+++ b/sysdeps/x86_64/tst-auditmod5b.c
@@ -86,6 +86,16 @@ la_objclose  (uintptr_t *cookie)
 }
 
 uintptr_t
+la_symbind32 (Elf32_Sym *sym, unsigned int ndx, uintptr_t *refcook,
+	      uintptr_t *defcook, unsigned int *flags, const char *symname)
+{
+  printf ("symbind32: symname=%s, st_value=%#lx, ndx=%u, flags=%u\n",
+	  symname, (long int) sym->st_value, ndx, *flags);
+
+  return sym->st_value;
+}
+
+uintptr_t
 la_symbind64 (Elf64_Sym *sym, unsigned int ndx, uintptr_t *refcook,
 	      uintptr_t *defcook, unsigned int *flags, const char *symname)
 {
diff --git a/sysdeps/x86_64/tst-auditmod6b.c b/sysdeps/x86_64/tst-auditmod6b.c
index b1c155a..886fc33 100644
--- a/sysdeps/x86_64/tst-auditmod6b.c
+++ b/sysdeps/x86_64/tst-auditmod6b.c
@@ -85,6 +85,16 @@ la_objclose  (uintptr_t *cookie)
 }
 
 uintptr_t
+la_symbind32 (Elf32_Sym *sym, unsigned int ndx, uintptr_t *refcook,
+	      uintptr_t *defcook, unsigned int *flags, const char *symname)
+{
+  printf ("symbind32: symname=%s, st_value=%#lx, ndx=%u, flags=%u\n",
+	  symname, (long int) sym->st_value, ndx, *flags);
+
+  return sym->st_value;
+}
+
+uintptr_t
 la_symbind64 (Elf64_Sym *sym, unsigned int ndx, uintptr_t *refcook,
 	      uintptr_t *defcook, unsigned int *flags, const char *symname)
 {
diff --git a/sysdeps/x86_64/tst-auditmod6c.c b/sysdeps/x86_64/tst-auditmod6c.c
index 88adb21..b2ee24d 100644
--- a/sysdeps/x86_64/tst-auditmod6c.c
+++ b/sysdeps/x86_64/tst-auditmod6c.c
@@ -85,6 +85,16 @@ la_objclose  (uintptr_t *cookie)
 }
 
 uintptr_t
+la_symbind32 (Elf32_Sym *sym, unsigned int ndx, uintptr_t *refcook,
+	      uintptr_t *defcook, unsigned int *flags, const char *symname)
+{
+  printf ("symbind32: symname=%s, st_value=%#lx, ndx=%u, flags=%u\n",
+	  symname, (long int) sym->st_value, ndx, *flags);
+
+  return sym->st_value;
+}
+
+uintptr_t
 la_symbind64 (Elf64_Sym *sym, unsigned int ndx, uintptr_t *refcook,
 	      uintptr_t *defcook, unsigned int *flags, const char *symname)
 {
diff --git a/sysdeps/x86_64/tst-auditmod7b.c b/sysdeps/x86_64/tst-auditmod7b.c
index 68052ef..f27076d 100644
--- a/sysdeps/x86_64/tst-auditmod7b.c
+++ b/sysdeps/x86_64/tst-auditmod7b.c
@@ -85,6 +85,16 @@ la_objclose  (uintptr_t *cookie)
 }
 
 uintptr_t
+la_symbind32 (Elf32_Sym *sym, unsigned int ndx, uintptr_t *refcook,
+	      uintptr_t *defcook, unsigned int *flags, const char *symname)
+{
+  printf ("symbind32: symname=%s, st_value=%#lx, ndx=%u, flags=%u\n",
+	  symname, (long int) sym->st_value, ndx, *flags);
+
+  return sym->st_value;
+}
+
+uintptr_t
 la_symbind64 (Elf64_Sym *sym, unsigned int ndx, uintptr_t *refcook,
 	      uintptr_t *defcook, unsigned int *flags, const char *symname)
 {